import win32.windows;
import std.stdio;
import std.string;
import std.utf;
import win32frame.writek;
import win32frame.WindowObject ;


class ComboBox : WindowObject {
  
  this(string name) {
    winc.lpszClassName  = cast(wchar*)("COMBOBOX") ;
    setStyle( (WS_CHILD | WS_VISIBLE) ) ;
    super(name) ;
  }

  int addString(string str){
    char[] cstr = str.dup ;
    return( SendMessage(this.hwnd , CB_ADDSTRING , 0 , cast(LPARAM)(cast(wchar*)(toUTF16(str ~ "\0")))) ) ;
  }

  int delString(int index){
    return( SendMessage(this.hwnd , CB_DELETESTRING, index, 0) ) ;
  }
    
  
  int getCount() {
    return( SendMessage(this.hwnd, CB_GETCOUNT , 0 , 0) ) ;
  }

  int getCursel() {
    return( SendMessage(this.hwnd, CB_GETCURSEL , 0 , 0) ) ;
  }

  string getCurLabel() {
    int    cur       = getCursel() ;
    int    label_len = SendMessage(this.hwnd, CB_GETLBTEXTLEN , cur , 0 )  ;
    string retstr    = "" ;
    
    if( label_len != CB_ERR ){
      wchar* strbuf=cast(wchar*)(std.gc.malloc(label_len+2)) ;
      if( SendMessage(this.hwnd, CB_GETLBTEXT, cur, cast(LPARAM)(strbuf)) != CB_ERR ){
	retstr = toUTF8( strbuf[0..label_len] ) ;
      }
      std.gc.hasNoPointers(cast(void*)(strbuf)) ;
    }
    return( retstr ) ;
  }
  
  int setCursel(int index) {
    return( SendMessage(this.hwnd, CB_SETCURSEL , index , 0) ) ;
  }

}
