import win32.windows;
import win32.commctrl;
import std.stdio;
import std.string;
import std.utf;
import win32frame.writek;
import win32frame.CommonControl;
import win32frame.WindowObject ;

uint MAKELPARAM(ushort a, ushort b) { return cast(uint) ((b << 16) | a); }
uint INDEXTOSTATEIMAGEMASK(uint i)  { return i << 12; }

class ListView : WindowObject {
  
  this(string name) {
    CommonControl cc = new CommonControl() ;
    winc.lpszClassName  = cast(wchar*)(WC_LISTVIEW) ;
    setStyle( (WS_CHILD | WS_VISIBLE) ) ;
    super(name) ;
  }

  COLORREF getBkColor() { //ListView_GetBkColor() {
    return( cast(COLORREF)(SendMessage(this.hwnd, LVM_GETBKCOLOR, 0, 0)) ) ;
  }

  HIMAGELIST getImageList(int i) { //ListView_GetImageList(int i) {
    return( cast(HIMAGELIST)(SendMessage(this.hwnd, LVM_GETIMAGELIST, i, 0)) ) ;
  }

  int getItemCount() { //ListView_GetItemCount() {
    return( SendMessage(this.hwnd, LVM_GETITEMCOUNT, 0, 0) ) ;
  }

  bool getItem(LPLVITEM pitem) { //ListView_GetItem(LPLVITEM pitem) {
    return( cast(bool)(SendMessage(this.hwnd, LVM_GETITEM, 0, cast(LPARAM)(pitem))) ) ;
  }

  bool setBkColor(COLORREF c) { //ListView_SetBkColor(COLORREF c) {
    return( cast(bool)(SendMessage(this.hwnd, LVM_SETBKCOLOR, 0, cast(LPARAM)(c))) ) ;
  }

  HIMAGELIST setImageList(HIMAGELIST h, int i) { //ListView_SetImageList(HIMAGELIST h, int i) {
    return( cast(HIMAGELIST)(SendMessage(this.hwnd, LVM_SETIMAGELIST, i, cast(LPARAM)(h))) ) ;
  }

  bool setItem(LPLVITEM i) { //ListView_SetItem(LPLVITEM i) {
    return( cast(bool)(SendMessage(this.hwnd, LVM_SETITEM, 0, cast(LPARAM)(i))) ) ;
  }

  int insertItem(LPLVITEM i) { //ListView_InsertItem(LPLVITEM i) {
    return( SendMessage(this.hwnd, LVM_INSERTITEM, 0, cast(LPARAM)(i)) ) ;
  }

  bool deleteItem(int i) { //ListView_DeleteItem(int i) {
    return( cast(bool)(SendMessage(this.hwnd, LVM_DELETEITEM, i, 0)) ) ;
  }

  bool deleteAllItems() { //ListView_DeleteAllItems() {
    return( cast(bool)(SendMessage(this.hwnd, LVM_DELETEALLITEMS, 0, 0)) ) ;
  }

  bool getCallbackMask() { //ListView_GetCallbackMask() {
    return( cast(bool)(SendMessage(this.hwnd, LVM_GETCALLBACKMASK, 0, 0)) ) ;
  }

  bool setCallbackMask(uint m) { //ListView_SetCallbackMask(uint m) {
    return( cast(bool)(SendMessage(this.hwnd, LVM_SETCALLBACKMASK, m, 0)) ) ;
  }

  int getNextItem(int i, uint f) { //ListView_GetNextItem(int i, uint f) {
    return( SendMessage(this.hwnd, LVM_GETNEXTITEM, i, MAKELPARAM(cast(ushort)(f), 0)) ) ;
  }

  int findItem(int i, LVFINDINFO* p) { //ListView_FindItem(int i, LVFINDINFO* p) {
    return( SendMessage(this.hwnd, LVM_FINDITEM, i, cast(LPARAM)(p)) ) ;
  }

  bool getItemRect(int i, LPRECT p, int c) { //ListView_GetItemRect(int i, LPRECT p, int c) {
    return( cast(bool)(SendMessage(this.hwnd, LVM_GETITEMRECT, i, p ? (p.left = c, cast(LPARAM) p) : 0)) ) ;
  }

  bool setItemPosition(int i, int x, int y) { //ListView_SetItemPosition(int i, int x, int y) {
    return( cast(bool)(SendMessage(this.hwnd, LVM_SETITEMPOSITION, i, MAKELPARAM(cast(ushort)(x), cast(ushort)(y)))) ) ;
  }

  bool getItemPosition(int i, POINT* p) { //ListView_GetItemPosition(int i, POINT* p) {
    return( cast(bool)(SendMessage(this.hwnd, LVM_GETITEMPOSITION, i, cast(LPARAM)(p))) ) ;
  }

  DWORD getItemSpacing(bool f) { //ListView_GetItemSpacing(bool f) {
    return( cast(DWORD)(SendMessage(this.hwnd, LVM_GETITEMSPACING, f, 0)) ) ;
  }

  int getStringWidth(LPCSTR s) { //ListView_GetStringWidth(LPCSTR s) {
    return( SendMessage(this.hwnd, LVM_GETSTRINGWIDTH, 0, cast(LPARAM)(s)) ) ;
  }

  int hitTest(LPLVHITTESTINFO p) { //ListView_HitTest(LPLVHITTESTINFO p) {
    return( SendMessage(this.hwnd, LVM_HITTEST, 0, cast(LPARAM)(p)) ) ;
  }

  bool ensureVisible(int i, bool f) { //ListView_EnsureVisible(int i, bool f) {
    return( cast(bool)(SendMessage(this.hwnd, LVM_ENSUREVISIBLE, i, MAKELPARAM(cast(ushort)(f), 0))) ) ;
  }

  bool scroll(int dx, int dy) { //ListView_Scroll(int dx, int dy) {
    return( cast(bool)(SendMessage(this.hwnd, LVM_SCROLL, dx, dy)) ) ;
  }

  bool redrawItems(int f, int l) { //ListView_RedrawItems(int f, int l) {
    return( cast(bool)(SendMessage(this.hwnd, LVM_REDRAWITEMS, f, l)) ) ;
  }

  bool arrange(uint c) { //ListView_Arrange(uint c) {
    return( cast(bool)(SendMessage(this.hwnd, LVM_ARRANGE, c, 0)) ) ;
  }

  HWND editLabel(int i) { //ListView_EditLabel(int i) {
    return( cast(HWND)(SendMessage(this.hwnd, LVM_EDITLABEL, i, 0)) ) ;
  }

  HWND getEditControl() { //ListView_GetEditControl() {
    return( cast(HWND)(SendMessage(this.hwnd, LVM_GETEDITCONTROL, 0, 0)) ) ;
  }

  bool getColumn(int i, LPLVCOLUMN p) { //ListView_GetColumn(int i, LPLVCOLUMN p) {
    return( cast(bool)(SendMessage(this.hwnd, LVM_GETCOLUMN, i, cast(LPARAM)(p))) ) ;
  }

  bool setColumn(int i, LPLVCOLUMN p) { //ListView_SetColumn(int i, LPLVCOLUMN p) {
    return( cast(bool)(SendMessage(this.hwnd, LVM_SETCOLUMN, i, cast(LPARAM)(p))) ) ;
  }

  int insertColumn(int i, LPLVCOLUMN p) { //ListView_InsertColumn(int i, LPLVCOLUMN p) {
    return( SendMessage(this.hwnd, LVM_INSERTCOLUMN, i, cast(LPARAM)(p)) ) ;
  }

  bool deleteColumn(int i) { //ListView_DeleteColumn(int i) {
    return( cast(bool)(SendMessage(this.hwnd, LVM_DELETECOLUMN, i, 0)) ) ;
  }

  int getColumnWidth(int i) { //ListView_GetColumnWidth(int i) {
    return( SendMessage(this.hwnd, LVM_GETCOLUMNWIDTH, i, 0) ) ;
  }

  bool setColumnWidth(int i, int x) { //ListView_SetColumnWidth(int i, int x) {
    return( cast(bool)(SendMessage(this.hwnd, LVM_SETCOLUMNWIDTH, i, MAKELPARAM(cast(ushort)(x), 0))) ) ;
  }

  HIMAGELIST createDragImage(int i, LPPOINT p) { //ListView_CreateDragImage(int i, LPPOINT p) {
    return( cast(HIMAGELIST)(SendMessage(this.hwnd, LVM_CREATEDRAGIMAGE, i, cast(LPARAM)(p))) ) ;
  }

  bool getViewRect(RECT* p) { //ListView_GetViewRect(RECT* p) {
    return( cast(bool)(SendMessage(this.hwnd, LVM_GETVIEWRECT, 0, cast(LPARAM)(p))) ) ;
  }

  COLORREF getTextColor() { //ListView_GetTextColor() {
    return( cast(COLORREF)(SendMessage(this.hwnd, LVM_GETTEXTCOLOR, 0, 0)) ) ;
  }

  bool setTextColor(COLORREF c) { //ListView_SetTextColor(COLORREF c) {
    return( cast(bool)(SendMessage(this.hwnd, LVM_SETTEXTCOLOR, 0, cast(LPARAM)(c))) ) ;
  }

  COLORREF getTextBkColor() { //ListView_GetTextBkColor() {
    return( cast(COLORREF)(SendMessage(this.hwnd, LVM_GETTEXTBKCOLOR, 0, 0)) ) ;
  }

  bool setTextBkColor(COLORREF c) { //ListView_SetTextBkColor(COLORREF c) {
    return( cast(bool)(SendMessage(this.hwnd, LVM_SETTEXTBKCOLOR, 0, cast(LPARAM)(c))) ) ;
  }

  int getTopIndex() { //ListView_GetTopIndex() {
    return( SendMessage(this.hwnd, LVM_GETTOPINDEX, 0, 0) ) ;
  }

  int getCountPerPage() { //ListView_GetCountPerPage() {
    return( SendMessage(this.hwnd, LVM_GETCOUNTPERPAGE, 0, 0) ) ;
  }

  bool getOrigin(LPPOINT p) { //ListView_GetOrigin(LPPOINT p) {
    return( cast(bool)(SendMessage(this.hwnd, LVM_GETORIGIN, 0, cast(LPARAM)(p))) ) ;
  }

  bool update(int i) { //ListView_Update(int i) {
    return( cast(bool)(SendMessage(this.hwnd, LVM_UPDATE, i, 0)) ) ;
  }

  void setItemState(int i, UINT d, UINT m) { //ListView_SetItemState(int i, UINT d, UINT m) {
    LV_ITEM _lvi;
    _lvi.stateMask = m;
    _lvi.state = d;
    SendMessage(this.hwnd, LVM_SETITEMSTATE, i, cast(LPARAM)(&_lvi)) ;
  }

  uint getItemState(int i, uint m) { //ListView_GetItemState(int i, uint m) {
    return( cast(uint)(SendMessage(this.hwnd, LVM_GETITEMSTATE, i, m)) ) ;
  }

  void getItemText(int i, int iS, LPTSTR s, int n) { //ListView_GetItemText(int i, int iS, LPTSTR s, int n) {
    LV_ITEM _lvi;
    _lvi.iSubItem = iS;
    _lvi.cchTextMax = n;
    _lvi.pszText = s;
    SendMessage(this.hwnd, LVM_GETITEMTEXT, i, cast(LPARAM)(&_lvi)) ;
  }

  void setItemText(int i, int iS, LPTSTR s) { //ListView_SetItemText(int i, int iS, LPTSTR s) {
    LV_ITEM _lvi;
    _lvi.iSubItem = iS;
    _lvi.pszText = s;
    SendMessage(this.hwnd, LVM_SETITEMTEXT, i, cast(LPARAM)(&_lvi)) ;
  }

  void setItemCount(int n) { //ListView_SetItemCount(int n) {
    SendMessage(this.hwnd, LVM_SETITEMCOUNT, n, 0);
  }

  bool sortItems(PFNLVCOMPARE f, LPARAM l) { //ListView_SortItems(PFNLVCOMPARE f, LPARAM l) {
    return( cast(bool)(SendMessage(this.hwnd, LVM_SORTITEMS, l, cast(LPARAM)(f))) ) ;
  }

  void setItemPosition32(int i, int x, int y) { //ListView_SetItemPosition32(int i, int x, int y) {
    POINT p;
    p.x = x;
    p.y = y;
    SendMessage(this.hwnd, LVM_SETITEMPOSITION32, i, cast(LPARAM)(&p)) ;
  }

  uint getSelectedCount() { //ListView_GetSelectedCount() {
    return( cast(uint)(SendMessage(this.hwnd, LVM_GETSELECTEDCOUNT, 0, 0)) ) ;
  }

  uint getCheckState(uint i) { //ListView_GetCheckState(uint i) {
    return( ((cast(uint) SendMessage(this.hwnd, LVM_GETITEMSTATE, i, LVIS_STATEIMAGEMASK)) >> 12) - 1 ) ;
  }

  void setCheckState(uint i, bool f) { //ListView_SetCheckState(uint i, bool f) {
    setItemState(i, INDEXTOSTATEIMAGEMASK(f ? 2 : 1), LVIS_STATEIMAGEMASK) ; 
  }

  bool getISearchString(LPSTR lpsz) { //ListView_GetISearchString(LPSTR lpsz) {
    return( cast(bool)(SendMessage(this.hwnd, LVM_GETISEARCHSTRING, 0, cast(LPARAM)(lpsz))) ) ;
  }
  
}
