import win32.windows;
import win32.commctrl;
import std.string;
import win32frame.writek;
import win32frame.WindowObject ;
import win32frame.CommonControlEx;

uint MAKELONG(ushort a, ushort b) {
        return cast(uint) ((b << 16) | a);
}

class TrackBar : WindowObject {
  
  this(string name) {
    CommonControlEx ccex = new CommonControlEx(ICC_COOL_CLASSES | ICC_BAR_CLASSES) ;
    winc.lpszClassName  = cast(wchar*)(TRACKBAR_CLASS) ;
    setStyle( (WS_CHILD | WS_VISIBLE ) ) ;
    super(name) ;
  }

  int getPos(){
    if( hwnd != null ){
      return( SendMessage( hwnd, TBM_GETPOS, 0,0 ) ) ;
    }
    return(-1) ;
  }

  int setPos(int pos, bool redraw=true){
    if( hwnd != null ){
      return( SendMessage( hwnd, TBM_SETPOS, cast(int)(redraw), pos ) ) ;
    }
    return(-1) ;
  }

  int setRange(int min, int max, bool redraw=true){
    if( hwnd != null ){
      return( SendMessage( hwnd, TBM_SETRANGE, cast(int)(redraw), MAKELONG(min,max) ) ) ;
    }
    return(-1) ;
  }

}
